(:

1.03s to filter and count valid elements

2.33s to write file

:)


import module namespace taricxml = "http://taricxml.fraktal.com.pl" at "taric_goods_extraction.xqm";

let $root := doc("/taric/base-20200101T000000-20200116T013000.xml")/*
let $goods_section := $root/IsztarHistoryItem/findGoodsNomenclatureByDatesResponse
let $goods_items := $goods_section/*

let $date_threshold := xs:dateTime("2020-01-20T12:00:00")

let $goods_items_valid := $goods_items[
	(: start date in the past :)
	xs:dateTime(validityStartDate/text()) <= $date_threshold 
	and
	(
		(: no end date, or end date in the future :)
		empty(validityEndDate) 
		or 
		xs:dateTime(validityEndDate/text()) > $date_threshold
	)
]

let $goods_info_useful := for $goods_elem in $goods_items_valid
	let $extracted_info := taricxml:extract_goods_info($goods_elem)
	order by $extracted_info/code
  return $extracted_info

let $goods_nomenclature_flat := <GoodsNomenclatureFlat>{$goods_info_useful}</GoodsNomenclatureFlat>

return (
	(: store in the DB, http://docs.basex.org/wiki/Database_Module#db:replace :)
	db:replace("taric", "goods_nomenclature_flat.xml", $goods_nomenclature_flat),
	(: write output to file system :)
	file:write("../data_out/goods_nomenclature_flat.xml", $goods_nomenclature_flat)
)



