xquery version "3.1";
module namespace page = 'http://taricxml.fraktal.com.pl/web';
 
declare function page:tree_search_hierarchical($tree as node()?, $lang as xs:string, $query as xs:string) as node()*
{
	let $name := $tree/description[@lang=$lang]/text()
	let $this_node_matches := contains(lower-case($name), $query)
	let $children_matching := $tree/GoodsTree ! page:tree_search_hierarchical(., $lang, $query)

	return if($this_node_matches or not(empty($children_matching))) then
		<G code="{$tree/@code}" name="{$name}">
			{ $children_matching }
		</G>
	else
		()
};

(: http://docs.basex.org/wiki/RESTXQ#Query_Parameters :)

declare
	%rest:GET 
	%rest:path("goods/search")
	%rest:query-param("query", "{$text_query}", "")
	%rest:query-param("lang", "{$lang}", "EN")
function page:hello($text_query as xs:string, $lang as xs:string) {
	if (string-length($text_query) = 0) then
		<error>No query specified</error>
	else
		let $doc := db:open("taric-base", "goods_nomenclature_tree.xml")/GoodsTree
		let $lang_up := upper-case($lang)
		let $result_hierarchy := page:tree_search_hierarchical($doc, $lang_up, lower-case($text_query))
		return <response>
			<query>{$text_query}</query>
			<lang>{$lang_up}</lang>
			<result-hierarchy>{$result_hierarchy}</result-hierarchy>
		</response>
};