(:
The TARIC XML is an extract from some object database, inluding the history of changes.
The database is a list of transactions - adding, modifying or deleting objects.

Specifically, each object tag contains a <metainfo> element describing the nature of the change:
the <opType> can be "C" for Create, "D" for Delete...

Two types of documents are published: snapshots for a given date or differential updates since the last published update.
We operate on the snapshot for 2020-01-16, so all transactions are creating objects.
We can therefore treat the database as a list of existing objects, and ignore the transaction data.

In this query, we verify that all opTypes are "C" (create) and that the latest transaction is in the past (2019-12-27).
Thus we will ignore the transaction info and consider all objects as existing.

Query took 7.1 s

However, some objects may still be outdated and they need to be filtered out.
See 04_process_validity_period
:)


let $goods_section := doc("/db/taric/02_import/goods_nomenclature.xml")/findGoodsNomenclatureByDatesResponse

let $transactions := $goods_section//metainfo
let $t_optypes := $transactions/opType/text()
let $t_dates := $transactions/transactionDate/xs:dateTime(text())

return <transactions>
	<num_transaction_metainfo>{count($transactions)}</num_transaction_metainfo>
	<uniqueOpTypes>{distinct-values($t_optypes)}</uniqueOpTypes>
	<transactionDates>
		<earliest>{min($t_dates)}</earliest>
		<latest>{max($t_dates)}</latest>
	</transactionDates>
</transactions>

